package com.company.traits.entity;

import com.company.traits.entity.key.TTaxaLinkTraitCompKey;
import io.jmix.core.metamodel.annotation.JmixEntity;
import jakarta.persistence.*;
import jakarta.validation.constraints.NotNull;

@JmixEntity
@Table(name = "T_TAXA_LINK_TRAIT", indexes = {
		@Index(name = "IDX_T_TAXA_LINK_TRAIT_TLRIDTAXON", columnList = "tlrIdTaxon")
})
@Entity
public class TTaxaLinkTrait {
	@EmbeddedId
	private TTaxaLinkTraitCompKey id;

	@NotNull
	@JoinColumns({
			@JoinColumn(name = "T_TAXA_TRAITS_TYPE_TTTCATEGORYNAME", referencedColumnName = "TTTCATEGORYNAME", nullable = false),
			@JoinColumn(name = "T_TAXA_TRAITS_TYPE_TTTTYPEVALUE", referencedColumnName = "TTTTYPEVALUE", nullable = false)
	})
	@ManyToOne(fetch = FetchType.LAZY, optional = false)
	private TTaxaTraitsType tTaxaTraitsType;

	@JoinColumn(name = "tlrIdTaxon", nullable = false, updatable = false, insertable = false)
	@NotNull
	@ManyToOne(fetch = FetchType.LAZY, optional = false)
	private TTaxa tlrIdTaxon;

	@Column(name = "tlrComment", length = 256)
	private String tlrComment;

	public String getTlrComment() {
		return tlrComment;
	}

	public void setTlrComment(String tlrComment) {
		this.tlrComment = tlrComment;
	}

	public TTaxa getTlrIdTaxon() {
		return tlrIdTaxon;
	}

	public void setTlrIdTaxon(TTaxa tlrIdTaxon) {
		this.tlrIdTaxon = tlrIdTaxon;
	}

	public TTaxaTraitsType getTTaxaTraitsType() {
		return tTaxaTraitsType;
	}

	public void setTTaxaTraitsType(TTaxaTraitsType tTaxaTraitsType) {
		this.tTaxaTraitsType = tTaxaTraitsType;
	}

	public TTaxaLinkTraitCompKey getId() {
		return id;
	}

	public void setId(TTaxaLinkTraitCompKey id) {
		this.id = id;
	}
}