package com.company.traits.entity;

import com.company.traits.entity.key.TTaxaTraitsTypeCompKey;
import io.jmix.core.metamodel.annotation.JmixEntity;
import jakarta.persistence.*;
import jakarta.validation.constraints.NotNull;

@JmixEntity
@Table(name = "tTaxaTraitsTypes", indexes = {
		@Index(name = "IDX_TTAXATRAITSTYPES_TTTCATEGORYNAME", columnList = "tttCategoryName")
})
@Entity
public class TTaxaTraitsType {
	@EmbeddedId
	private TTaxaTraitsTypeCompKey id;

	@JoinColumn(name = "tttCategoryName", nullable = false, updatable = false, insertable = false)
	@NotNull
	@ManyToOne(fetch = FetchType.LAZY, optional = false)
	private TTaxaTraitsCategory tttCategoryName;

	@Column(name = "tttDescription")
	private String tttDescription;

	@Column(name = "tttGuid", length = 36)
	private String tttGuid;

	public TTaxaTraitsCategory getTttCategoryName() {
		return tttCategoryName;
	}

	public void setTttCategoryName(TTaxaTraitsCategory tttCategoryName) {
		this.tttCategoryName = tttCategoryName;
	}

	public String getTttGuid() {
		return tttGuid;
	}

	public void setTttGuid(String tttGuid) {
		this.tttGuid = tttGuid;
	}

	public String getTttDescription() {
		return tttDescription;
	}

	public void setTttDescription(String tttDescription) {
		this.tttDescription = tttDescription;
	}

	public TTaxaTraitsTypeCompKey getId() {
		return id;
	}

	public void setId(TTaxaTraitsTypeCompKey id) {
		this.id = id;
	}
}