package com.company.traits.entity.key;

import io.jmix.core.MetadataTools;
import io.jmix.core.metamodel.annotation.DependsOnProperties;
import io.jmix.core.metamodel.annotation.InstanceName;
import io.jmix.core.metamodel.annotation.JmixEntity;
import io.jmix.core.metamodel.datatype.DatatypeFormatter;
import jakarta.persistence.Column;
import jakarta.persistence.Embeddable;

import java.util.Objects;

@JmixEntity
@Embeddable
public class TTaxaLinkTraitCompKey {
	@Column(name = "tlrCategoryName", nullable = false, unique = true, length = 50)
	private String tlrCategoryName;

	@Column(name = "tlrIdTaxon", nullable = false, unique = true)
	private Integer tlrIdTaxon;

	@Column(name = "tlrTypeValue", nullable = false, unique = true, length = 30)
	private String tlrTypeValue;

	public String getTlrTypeValue() {
		return tlrTypeValue;
	}

	public void setTlrTypeValue(String tlrTypeValue) {
		this.tlrTypeValue = tlrTypeValue;
	}

	public Integer getTlrIdTaxon() {
		return tlrIdTaxon;
	}

	public void setTlrIdTaxon(Integer tlrIdTaxon) {
		this.tlrIdTaxon = tlrIdTaxon;
	}

	public String getTlrCategoryName() {
		return tlrCategoryName;
	}

	public void setTlrCategoryName(String tlrCategoryName) {
		this.tlrCategoryName = tlrCategoryName;
	}

	@Override
	public int hashCode() {
		return Objects.hash(tlrIdTaxon, tlrTypeValue, tlrCategoryName);
	}

	@Override
	public boolean equals(Object o) {
		if (this == o) return true;
		if (o == null || getClass() != o.getClass()) return false;
		TTaxaLinkTraitCompKey entity = (TTaxaLinkTraitCompKey) o;
		return Objects.equals(this.tlrIdTaxon, entity.tlrIdTaxon) &&
				Objects.equals(this.tlrTypeValue, entity.tlrTypeValue) &&
				Objects.equals(this.tlrCategoryName, entity.tlrCategoryName);
	}

	@InstanceName
	@DependsOnProperties({"tlrCategoryName", "tlrTypeValue", "tlrIdTaxon"})
	public String getInstanceName(MetadataTools metadataTools, DatatypeFormatter datatypeFormatter) {
		return String.format("%s %s %s",
				metadataTools.format(tlrCategoryName),
				metadataTools.format(tlrTypeValue),
				datatypeFormatter.formatInteger(tlrIdTaxon));
	}
}