package com.company.traits.view.ttaxalinktrait;

import com.company.traits.entity.TTaxa;
import com.company.traits.entity.TTaxaLinkTrait;
import com.company.traits.entity.TTaxaTraitsType;
import com.company.traits.entity.key.TTaxaLinkTraitCompKey;
import com.company.traits.view.main.MainView;
import com.vaadin.flow.component.AbstractField;
import com.vaadin.flow.router.Route;
import io.jmix.core.EntityStates;
import io.jmix.core.metamodel.datatype.Datatype;
import io.jmix.flowui.component.textfield.TypedTextField;
import io.jmix.flowui.component.valuepicker.EntityPicker;
import io.jmix.flowui.model.InstanceContainer;
import io.jmix.flowui.view.*;
import liquibase.structure.core.DataType;
import org.springframework.beans.factory.annotation.Autowired;

@Route(value = "t-taxa-link-traits/:id", layout = MainView.class)
@ViewController(id = "TTaxaLinkTrait.detail")
@ViewDescriptor(path = "t-taxa-link-trait-detail-view.xml")
@EditedEntityContainer("tTaxaLinkTraitDc")
public class TTaxaLinkTraitDetailView extends StandardDetailView<TTaxaLinkTrait> {
    @ViewComponent
    private TypedTextField<String> idTlrIdTaxonField;
    @ViewComponent
    private TypedTextField<String> tlrIdTaxonField;
    @ViewComponent
    private InstanceContainer<TTaxaLinkTrait> tTaxaLinkTraitDc;

    @Autowired
    private EntityStates entityStates;


    @Subscribe
    public void onInit(final InitEvent event) {
        String x = tlrIdTaxonField.getValue();

        tTaxaLinkTraitDc.addItemPropertyChangeListener(propertyChangeEvent -> {
            if (propertyChangeEvent.getProperty().equals("tTaxaTraitsType")) {
                TTaxaTraitsType tttType = (TTaxaTraitsType) propertyChangeEvent.getValue();
                TTaxaLinkTraitCompKey compKey = getEditedEntity().getId();

                if (tttType != null) {
                    compKey.setTlrTypeValue(tttType.getId().getTttTypeValue());
                    compKey.setTlrCategoryName(tttType.getTttCategoryName().getTtcCategoryName());
                } else {
                    compKey.setTlrTypeValue(null);
                    compKey.setTlrCategoryName(null);
                }
            }
        });

    }


    @Subscribe
    public void onBeforeShow(final BeforeShowEvent event) {
        //idTlrIdTaxonField.setValue(tlrIdTaxonField.getValue());
        //idTlrIdTaxonField = tlrIdTaxonField;

        TTaxaLinkTrait entity = getEditedEntity();
        if (entityStates.isNew(entity) && entity.getTlrIdTaxon() != null) {
            entity.getId().setTlrIdTaxon(entity.getTlrIdTaxon().getId());
        }
    }


    @Subscribe("tTaxaTraitsTypeField")
    public void onTTaxaTraitsTypeFieldComponentValueChange(final AbstractField.ComponentValueChangeEvent<EntityPicker<?>, ?> event) {
        String id = idTlrIdTaxonField.getValue();

    }


}